/*
 *	app.h
 *
 *	|`bƂɂ`ǂ
 *
 *	* Fri Mar 24 04:10:00 JST 2006 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO -1 /*{{TODO}}*/

/* K[x[WRN^[gꍇ́AUSE_GCV{`Ă */
//#define USE_GC /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
//#define LDIRECT_INTERVAL 12 /*{{TODO}}*/

/* cʃ[hgꍇ́AV_SCREENV{`Ă */
//#define V_SCREEN /*{{TODO}}*/
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* yCugꍇ́AUSE_MUSICV{`Ă */
//#define USE_MUSIC /*{{TODO}}*/
#ifdef USE_MUSIC
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/* eNX`Xgꍇ́AUSE_TEXTUREV{`ĂB */
#define USE_TEXTURE /*{{TODO}}*/
#ifdef USE_TEXTURE
#define TEXTURE_(name) TEX_##name,
enum {
#include "texture.h"
	TEXTURE_COUNT,
};
extern TEXTURE texture_table[TEXTURE_COUNT];
#undef TEXTURE_
#endif /*USE_TEXTURE*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* 3D`gꍇ́A
 * EUSE_3DV{`ĂB
 * EFRONTɓK؂ȑOʃNbsO(_`eʋ)w肵ĂB
 * EBACK ɓK؂ȔwʃNbsO(_`E)w肵ĂB
 * EFOVY ɓK؂Ȑpxw肵ĂB
 */
//#define USE_3D /*{{TODO}}*/
#ifdef USE_3D
#define FRONT	fld(1)
#define BACK	fld(100)
#define FOVY	DEG(90)
#endif /*USE_3D*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT /*{{TODO}}*/
//#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_RI)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* |[Y@\gꍇ́AUSE_PAUSEV{`ĂB
 * ܂AAvP[V̒ʏwiFɂ킹āAPAUSE_COLORIĂB
 */
#define USE_PAUSE /*{{TODO}}*/
#ifdef USE_PAUSE
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#ifndef LDIRECT_INTERVAL
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#else /*LDIRECT_INTERVAL*/
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#endif /*LDIRECT_INTERVAL*/
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */
#endif /*USE_PAUSE*/

/* USBt@CVXeG~[Vgꍇ́AUSE_UFEV{`ĂB */
//#define USE_UFE

/* USBt@CVXeG~[Vƃg[Xo͕͂pł܂B */
#if defined(USE_UFE) && defined(TRACE_ON) && (TRACE_ON)
#error USBt@CVXeG~[Vƃg[Xo͕͂pł܂B
#endif /*defined(USE_UFE) && defined(TRACE_ON) && (TRACE_ON)*/

/* TCP/IPvgRXC[ggꍇ́AUSE_TCPIPV{`ĂB */
//#define USE_TCPIP

/* TCP/IPvgRXC[gƃg[Xo͕͂pł܂B */
#if defined(USE_TCPIP) && defined(TRACE_ON) && (TRACE_ON)
#error TCP/IPvgRXC[gƃg[Xo͕͂pł܂B
#endif /*defined(USE_TCPIP) && defined(TRACE_ON) && (TRACE_ON)*/

#ifdef USE_TCPIP
#include "tcpip.h"
#endif /*USE_TCPIP*/

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define CELL_W		7			/* Z   [sNZ] */
#define CELL_H		7			/* Z [sNZ] */

#define FIELD_COLS	7			/* tB[h   [Z] */
#define FIELD_ROWS	(OUTER_ROWS + 12)	/* tB[hs   [Z] (ʊO+ʓ) */
#define OUTER_ROWS	3			/* tB[hs   [Z] (ʊO) */
#define CENTER_COL	(FIELD_COLS / 2)	/* tB[h [Z] */

#define INFO_X		52			/* GǍ_W [sNZ] */
#define INFO_Y		 0

#define SCORE_X		54			/* XRǍ_W [sNZ] */
#define SCORE_Y		44

#define HURRY_X		64			/* HURRY UP!̒SW [sNZ] */
#define HURRY_Y		35

#define FALL_SPEED	fld(0.25)		/* ݂ɂړx */
#define LAND_DELAY	SEC(1)			/* ݂ɂڒfBC */

#define ERASE_INTERVAL	SEC(0.15)		/* ŃC^[o */

/* app_stat */
#define APP_STAT_GAME	1
#define APP_STAT_DEMO	2

/****************************************************************************
 *	
 ****************************************************************************/

/* CELL.type */
//				0	/*          coloŕA0Œ */
#define CELL_TYPE_NYAN		1	/* ɂor colorɂ́AF(1-4)i[Ă */
#define CELL_TYPE_HARI		2	/* ͂ɂ   colorɂ́AF(1-4)i[Ă */
#define CELL_TYPE_OJAMA		3	/*      coloŕA0Œ */

/* CELL.stat */
//				0	/* ʏ */
#define CELL_STAT_FALL		1	/*  */
#define CELL_STAT_ERASE		2	/*  */

/* CELL.root
 * - ͂ɂɗאڂɂAgT_hƌĂԂƂɂ܂B
 * - T_ɘAȂɂA܂́A͂ɂɁAT_i[܂B
 * - ̂ɂ񂪁A̒T_ɘAȂꍇA[x̒T_i[܂B
 *   [xȂ΁AɒTD悵܂B(㏑܂!!)
 * - ̂͂ɂ񂪁A̒T_ɘAȂꍇAŒT̒T_ŏ㏑܂B
 *   ͂ɂɂƂĂ̒T_́AŃ}[N̈ӖȂ̂ŁAɈႢ͂܂B
 * - ʊO(row=0)͒TȂ̂ŁALroot͕K0ȊO̒lɂȂ܂B
 *   ]āACELL.root0ۂɂāATς݂AT𔻒肷邱Ƃł܂B
 */
#define CELL_ROOT(col, row)	((row) * FIELD_COLS + (col))

typedef struct _CELL {
	short type;	/*  (CELL_TYPE_*) */
	short color;	/* F */
	short stat;	/*  (CELL_STAT_*) */
	short root;	/* T_ */
	short depth;	/* T_1Ƃ[x */
	short inner;	/* [_łȂ1ɂȂ */
	short cnt;	/* ėpJE^ */
	short age;	/* ͂ɂ񐶑JE^ */
} CELL;

/****************************************************************************
 *	
 ****************************************************************************/

/* FIRE.type */
#define FIRE_TYPE_YOYAKU	255	/* \ (fire_gen2()ɂčUorEɕύX)  */
#define FIRE_TYPE_KOUGEKI	1	/* U ([_瑊tB[h[) */
#define FIRE_TYPE_SOUSAI	2	/* E ([_玩tB[h[)   */

typedef struct _FIRE {
	unsigned char type;	/* 0 = , FIRE_TYPE_* = gp */
	unsigned char stat;	/* 0 = oO`[_ʒuŃAj[V */
				/* 1 = [_ڕWʒuֈړ           */
				/* 2 = ڕWʒuŃAj[V         */
	short cnt;		/* Aj[VJE^ */
	short col;		/* [_Z̗ԍ */
	short row;		/*           sԍ */
} FIRE;

#define MAX_FIRE		16	/* UGtFNg̍őo */

/****************************************************************************
 *	
 ****************************************************************************/

/* ܃L[pӂŔAȉ̂ƂłB
 * - SideSideւ܂𑗂荞ނ̂́Aerase_done()̏łB
 *   erase_done()́AtB[h̏ł^C~OŌĂ΂܂B
 *   A̎_ł͂܂AtB[hւ̍UGtFNg쒆łA
 *   erase_done()̏̒ŁAځÂܐ𑝂₵Ă܂̂ł́A
 *   UGtFNgOɁAtB[hɂ܂~Ă܂\܂B
 *   (荞݂̃^C~OƁÃ^[̋؂̃^C~OA傤Ǎꍇ)
 * - ƌāAUGtFNg܂erase_done()̔x点̂ł́A
 *   tB[h́AŊRJn̎Ԃ󂢂Ă܂AsRłB
 *   tB[h̏ƁAUGtFNg̏́A񓯊ɐisȂ΂Ȃ܂B
 * - ŁAerase_done()xāAɂ܂荞܂悤A
 *   ܃L[pӂ܂B
 *   ɂ̏ŃAj[VƁAUGtFNǵAI[o[bvĂ̂ŁA
 *   xׂԂ́A(UGtFNg - ɂ̏ŃAj[V)łB
 *   XYĂĂ薳̂ŁAojama_queue_gen()̏ɂāAK؂ɒĂB
 * - Ȏ荞݂sȑOɁA̘Aꍇ̂߂ɁAL[ƂĂ܂B
 *   xԂ͔ɒẐŁAGg2xŏ[Ȃ̂łA]T4Ƃ܂B
 */

#define MAX_OJAMA_QUEUE		4	/* ܃L[̃Gg */

typedef struct _OJAMA_QUEUE {
	short ojama;		/* ܂𑗂荞ސ (0 = 󂫃Gg) */
	short delay;		/* cx */
} OJAMA_QUEUE;

/****************************************************************************
 *	
 ****************************************************************************/

/* SIDE.stat */
#define SIDE_STAT_READY		0	/* zu̗AREADYAGO! */
#define SIDE_STAT_KUMI		1	/* ݂ɂړ */
#define SIDE_STAT_FALL		2	/*  */
#define SIDE_STAT_ERASE		3	/*  */
#define SIDE_STAT_FIRE		4	/* UGtFNg҂ */
#define SIDE_STAT_OJAMA		5	/* ܏o */
#define SIDE_STAT_HARI		6	/* ͂ɂω */
#define SIDE_STAT_WIN		7	/*  */
#define SIDE_STAT_LOSE		8	/*  */

/* SIDE.kumi_rot
 * - kumi_rot_tbl[]̏ԂƁAĂKv܂B
 */
#define KUMI_ROT_UP		0	/* SZɑ΂āAOZ */
#define KUMI_ROT_RI		1	/*                             E */
#define KUMI_ROT_DN		2	/*                              */
#define KUMI_ROT_LF		3	/*                              */

/* SIDE.quake_stat */
#define QUAKE_STAT_ERASE	1	/* ɂŒnk */
#define QUAKE_STAT_OJAMA	2	/* ܗnk */
#define QUAKE_STAT_CLEAR	3	/* Xe[WNA */

typedef struct _SIDE {
	/* ʏ */
	short i_side;					/* TCh (0 = 1P, 1 = 2P) */
	short i_ch;					/* L */
	int score;					/* XRA */
	short max_branch;				/* ő啪 */
	short max_length;				/* ő咷 */
	//
	short stat;					/*  (SIDE_STAT_*) */
	/*{{erase_init()ɂĊmBZʎZłȂP̕]łB*/
	short attack;					/* U */
	short branch;					/* ̏ł̍ő啪 */
	short length;					/* ̏ł̍ő咷 */
	/*}}erase_init()ɂĊmBZʎZłȂP̕]łB*/

	/* vl[` */
	struct _THINK* think;				/* NULL = vC[, <>NULL = CPU */

	/* `ʒu */
	short disp_field_x;				/* tB[ȟ_W [sNZ] */
	short disp_field_y;
	short disp_next_x[2];				/* NEXŤ_W [sNZ] */
	short disp_next_y[2];
	short disp_max_branch_x;			/* ő啪̌_W [sNZ] */
	short disp_max_branch_y;
	short disp_max_length_x;			/* ő咷̌_W [sNZ] */
	short disp_max_length_y;

	/* NEXT */
	int next_seed;					/* NEXTV[h */
	short next[2/*,X*/][2/*,O*/];		/* F */

	/* ݂ɂ */
	short kumi[2/*,O*/];				/* F */
	short kumi_hari;				/* 0 = ɂ, 1 = ͂ɂ */
	short kumi_cnt;					/* ėpJE^ */
	short kumi_col;					/* SZ̗ */
	short kumi_row;					/*           s */
	short kumi_rot;					/* ] (KUMI_ROT_*) */
	fixed kumi_pos;					/* JE^ [sNZ] (CELL_H0) */

	/* nk */
	short quake_stat;				/* nk^Cv (QUAKE_STAT_*) */
	short quake_cnt;				/* nkJE^ */
	short quake_pos[FIELD_COLS];			/* nkItZbg [sNZ] */

	/*  */
	short ojama;					/*  (ɗL) */
	short ojama_num[FIELD_COLS];			/* ܂񂲂Ƃɕ (SIDE_STAT_OJAMÂݗL) */
	OJAMA_QUEUE ojama_queue[MAX_OJAMA_QUEUE];	/* ܃L[ */

	/* UGtFNg */
	FIRE fire[MAX_FIRE];				/* UGtFNg */

	/* tB[h */
	CELL field[FIELD_ROWS][FIELD_COLS];		/* tB[h */
} SIDE;

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _THINK_VALUE {
	short valid;		/* 1 = ]Ώ, 0 = ]ΏۊO */
	short attack;		/* U */
	short ojama;		/* tB[ĥܐ */
	short form;		/* tB[ĥɂzu */
	fixed space;		/* ʓ̋󂫃ZwW (0.0`1.0) */
} THINK_VALUE;

typedef struct _THINK {
	short done;		/* 0 = , 1 =  */

	short hari;		/* ʂ͂ɂ */
	short col;		/*              */
	short rot;		/*     ]       */

	SIDE side;		/* Side̕ */

	THINK_VALUE value[2/*hari*/][FIELD_COLS/*col*/][4/*rot*/];
} THINK;

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _LEVEL {
	short spdup_row;		/* Jnsԍ */
	short space_rate;		/* 󂫃ZwW=1.0̖ڕWU */
} LEVEL;

/****************************************************************************
 *	
 ****************************************************************************/

typedef struct _GAME {
	short rate;			/* [g (0`) */
	short rate_cnt;			/* [gpJE^ (0`SEC(60)-1) */

	short hurry_stat;		/* HURRY UP!  (0 = o, 1` = o) */
	short hurry_cnt;		/* HURRY UP! Aj[VJE^ */

	short i_bg;			/* wi */

	SIDE side[2/*1P,2P*/];		/* Side */
	THINK think[2/*1P,2P*/];	/* vl[` */
} GAME;

/****************************************************************************
 *	
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void delay(int frame);
int demo_main();
void game_main();

void game_init();
void side_init(int i_side);
void stage_init();
void game_ready();
void game_clear();
void game_over();
void score_add(SIDE* side, int pts);

void bg_disp(fixed anim/*1.00.0*/);
void info_disp(int i_side);
void field_disp(int i_side);
void kumi_disp(int i_side);
void cell_disp(int i_side, CELL* cell, int x, int y);
void hurry_disp();

void kumi_init(SIDE* side);
int kumi_action(SIDE* side);
int kumi_test(SIDE* side, int col, int row, int rot);
void kumi_done(SIDE* side);

int fall_action(SIDE* side);

int erase_test(SIDE* side);
void erase_init(SIDE* side);
int erase_action(SIDE* side);
void erase_done(SIDE* side);

void ojama_init(SIDE* side);
int ojama_action(SIDE* side);

void hari_init(SIDE* side);
int hari_action(SIDE* side);

void think_init(THINK* think, SIDE* side);
void think_next(THINK* think);
void think_eval(THINK* think, SIDE* side, THINK_VALUE* value);
int think_compare(THINK* think, const THINK_VALUE* v1, const THINK_VALUE* v2);

void fire_gen1(SIDE* side, int col, int row, int cnt);
void fire_gen2(SIDE* side, int type);
int fire_action(SIDE* side);
void fire_disp(int i_side);

void ojama_queue_gen(SIDE* side, int ojama);
void ojama_queue_action(SIDE* side);

extern const char form_tbl[256]; /* form_tbl.c */

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
