#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _FORM {
	unsigned char cell[3/*row*/][3/*col*/];
	unsigned char flag;
	unsigned char ref;
	char pts;
} FORM;

FORM form_tbl[256];

int
main()
{
	int col;
	int row;
	int i_form;
	FORM* form;
	unsigned char (*cell)[3];

	int i;
	int j;
	int a;
	char* s;

	for(i_form = 0; i_form < 256; i_form++) {
		form = &form_tbl[i_form];
		cell = form->cell;

		cell[0][0] = (i_form >> 0) & 1;
		cell[0][1] = (i_form >> 1) & 1;
		cell[0][2] = (i_form >> 2) & 1;
		cell[1][0] = (i_form >> 3) & 1;
		cell[1][2] = (i_form >> 4) & 1;
		cell[2][0] = (i_form >> 5) & 1;
		cell[2][1] = (i_form >> 6) & 1;
		cell[2][2] = (i_form >> 7) & 1;

		if(form->flag) {
			continue;
		}

		if(!i_form) {
			form->pts = 0;
		} else {
			form->pts = -1;
		}

		for(i = 0; i < 16; i++) {
			unsigned char tmp1[3][3];
			unsigned char tmp2[3][3];
			memcpy(tmp1, cell, 3 * 3);

			/* ȂȂߕɊ֌W̖ZtH[ƌȂB */
			if(i & 1) {
				if(!tmp1[0][1] && !tmp1[1][2]) {
					tmp1[0][2] = 1;
				}
			}
			if(i & 2) {
				if(!tmp1[1][2] && !tmp1[2][1]) {
					tmp1[2][2] = 1;
				}
			}
			if(i & 4) {
				if(!tmp1[2][1] && !tmp1[1][0]) {
					tmp1[2][0] = 1;
				}
			}
			if(i & 8) {
				if(!tmp1[1][0] && !tmp1[0][1]) {
					tmp1[0][0] = 1;
				}
			}

			/* ] */
			a = 0;
			tmp2[0][0] = tmp1[0][0];
			tmp2[0][1] = tmp1[0][1];
			tmp2[0][2] = tmp1[0][2];
			tmp2[1][0] = tmp1[1][0];
			tmp2[1][2] = tmp1[1][2];
			tmp2[2][0] = tmp1[2][0];
			tmp2[2][1] = tmp1[2][1];
			tmp2[2][2] = tmp1[2][2];
			a |= tmp2[0][0] << 0;
			a |= tmp2[0][1] << 1;
			a |= tmp2[0][2] << 2;
			a |= tmp2[1][0] << 3;
			a |= tmp2[1][2] << 4;
			a |= tmp2[2][0] << 5;
			a |= tmp2[2][1] << 6;
			a |= tmp2[2][2] << 7;
			if((a > i_form) && (!form_tbl[a].flag)) {
				form_tbl[a].flag = 1;
				form_tbl[a].ref = i_form;
			}

			/* E] */
			a = 0;
			tmp2[0][0] = tmp1[0][2-0];
			tmp2[0][1] = tmp1[0][2-1];
			tmp2[0][2] = tmp1[0][2-2];
			tmp2[1][0] = tmp1[1][2-0];
			tmp2[1][2] = tmp1[1][2-2];
			tmp2[2][0] = tmp1[2][2-0];
			tmp2[2][1] = tmp1[2][2-1];
			tmp2[2][2] = tmp1[2][2-2];
			a |= tmp2[0][0] << 0;
			a |= tmp2[0][1] << 1;
			a |= tmp2[0][2] << 2;
			a |= tmp2[1][0] << 3;
			a |= tmp2[1][2] << 4;
			a |= tmp2[2][0] << 5;
			a |= tmp2[2][1] << 6;
			a |= tmp2[2][2] << 7;
			if((a > i_form) && (!form_tbl[a].flag)) {
				form_tbl[a].flag = 1;
				form_tbl[a].ref = i_form;
			}

			/* ㉺] */
			a = 0;
			tmp2[0][0] = tmp1[2-0][0];
			tmp2[0][1] = tmp1[2-0][1];
			tmp2[0][2] = tmp1[2-0][2];
			tmp2[1][0] = tmp1[2-1][0];
			tmp2[1][2] = tmp1[2-1][2];
			tmp2[2][0] = tmp1[2-2][0];
			tmp2[2][1] = tmp1[2-2][1];
			tmp2[2][2] = tmp1[2-2][2];
			a |= tmp2[0][0] << 0;
			a |= tmp2[0][1] << 1;
			a |= tmp2[0][2] << 2;
			a |= tmp2[1][0] << 3;
			a |= tmp2[1][2] << 4;
			a |= tmp2[2][0] << 5;
			a |= tmp2[2][1] << 6;
			a |= tmp2[2][2] << 7;
			if((a > i_form) && (!form_tbl[a].flag)) {
				form_tbl[a].flag = 1;
				form_tbl[a].ref = i_form;
			}

			/* ㉺E] */
			a = 0;
			tmp2[0][0] = tmp1[2-0][2-0];
			tmp2[0][1] = tmp1[2-0][2-1];
			tmp2[0][2] = tmp1[2-0][2-2];
			tmp2[1][0] = tmp1[2-1][2-0];
			tmp2[1][2] = tmp1[2-1][2-2];
			tmp2[2][0] = tmp1[2-2][2-0];
			tmp2[2][1] = tmp1[2-2][2-1];
			tmp2[2][2] = tmp1[2-2][2-2];
			a |= tmp2[0][0] << 0;
			a |= tmp2[0][1] << 1;
			a |= tmp2[0][2] << 2;
			a |= tmp2[1][0] << 3;
			a |= tmp2[1][2] << 4;
			a |= tmp2[2][0] << 5;
			a |= tmp2[2][1] << 6;
			a |= tmp2[2][2] << 7;
			if((a > i_form) && (!form_tbl[a].flag)) {
				form_tbl[a].flag = 1;
				form_tbl[a].ref = i_form;
			}
		}
	}

	for(i = 0; i < 2; i++) {
		for(j = -99; j < 99; j++) {
			for(i_form = 0; i_form < 256; i_form++) {
				form = &form_tbl[i_form];
				cell = form->cell;

				if(form->flag != i) {
					continue;
				}

				a = 0;
				if(i == 0) {
					for(row = 0; row <= 2; row++) {
						for(col = 0; col <= 2; col++) {
							a += cell[row][col];
						}
					}
					if(cell[0][1] && cell[0][2] && cell[1][2]) a -= 2;
					if(cell[1][2] && cell[2][2] && cell[2][1]) a -= 2;
					if(cell[2][1] && cell[2][0] && cell[1][0]) a -= 2;
					if(cell[1][0] && cell[0][0] && cell[0][1]) a -= 2;
					if(!cell[0][0] && !cell[0][1] && !cell[0][2]) a--;
					if(!cell[2][0] && !cell[2][1] && !cell[2][2]) a--;
					form->pts = a + 2/**/;
				}
				if(a != j) {
					continue;
				}

				for(row = 0; row <= 2; row++) {
					printf("/* ");
					for(col = 0; col <= 2; col++) {
						if((col == 1) && (row == 1)) {
							s = "";
						} else {
							if(cell[row][col]) {
								s = "";
							} else {
								s = "@";
							}
						}
						printf("%s", s);
					}
					printf(" */\n");
				}
				if(form->flag) {
					printf("#define FORM_%02X\tFORM_%02X\n", i_form, form->ref);
				} else {
					printf("#define FORM_%02X\t%d\n", i_form, form->pts);
				}
			}
		}
	}

	printf("\n");

	printf("const char form_tbl[256] = {\n");
	for(i_form = 0; i_form < 256; i_form++) {
		printf("\tFORM_%02X,\n", i_form);
	}
	printf("};\n");
}
